# RingOfPolynomialsOver< T > Class Template Reference

`#include <polynomi.h>`

Inheritance diagram for RingOfPolynomialsOver< T >:

List of all members.

## Detailed Description

### template<class T>
class RingOfPolynomialsOver< T >

Ring of polynomials over another ring.

Definition at line 310 of file polynomi.h.

## Public Types
typedef T | CoefficientRing
typedef PolynomialOver< T > | Element
typedef Element::CoefficientType | CoefficientType
typedef Element::RandomizationParameter | RandomizationParameter
## Public Member Functions
| RingOfPolynomialsOver (const CoefficientRing &ring)
Element | RandomElement (RandomNumberGenerator &rng, const RandomizationParameter &parameter)
bool | Equal (const Element &a, const Element &b) const
const Element & | Identity () const
const Element & | Add (const Element &a, const Element &b) const
Element & | Accumulate (Element &a, const Element &b) const
const Element & | Inverse (const Element &a) const
const Element & | Subtract (const Element &a, const Element &b) const
Element & | Reduce (Element &a, const Element &b) const
const Element & | Double (const Element &a) const
const Element & | MultiplicativeIdentity () const
const Element & | Multiply (const Element &a, const Element &b) const
const Element & | Square (const Element &a) const
bool | IsUnit (const Element &a) const
const Element & | MultiplicativeInverse (const Element &a) const
const Element & | Divide (const Element &a, const Element &b) const
const Element & | Mod (const Element &a, const Element &b) const
void | DivisionAlgorithm (Element &r, Element &q, const Element &a, const Element &d) const
Element | Interpolate (const CoefficientType x[], const CoefficientType y[], unsigned int n) const
CoefficientType | InterpolateAt (const CoefficientType &position, const CoefficientType x[], const CoefficientType y[], unsigned int n) const
virtual void | DivisionAlgorithm (Element &r, Element &q, const Element &a, const Element &d) const =0
virtual const Element & | Mod (const Element &a, const Element &b) const =0
virtual const Element & | Gcd (const Element &a, const Element &b) const
virtual bool | IsUnit (const Element &a) const =0
virtual const Element & | Multiply (const Element &a, const Element &b) const =0
virtual const Element & | MultiplicativeInverse (const Element &a) const =0
virtual const Element & | Square (const Element &a) const
virtual const Element & | Divide (const Element &a, const Element &b) const
virtual Element | Exponentiate (const Element &a, const Integer &e) const
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
virtual const AbstractGroup < PolynomialOver< T > > & | MultiplicativeGroup () const
virtual bool | Equal (const Element &a, const Element &b) const =0
virtual const Element & | Add (const Element &a, const Element &b) const =0
virtual const Element & | Inverse (const Element &a) const =0
virtual bool | InversionIsFast () const
virtual const Element & | Double (const Element &a) const
virtual const Element & | Subtract (const Element &a, const Element &b) const
virtual Element & | Accumulate (Element &a, const Element &b) const
virtual Element & | Reduce (Element &a, const Element &b) const
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
## Protected Member Functions
void | CalculateAlpha (std::vector< CoefficientType > &alpha, const CoefficientType x[], const CoefficientType y[], unsigned int n) const
## Protected Attributes
CoefficientRing | m_ring
Element | result
## Classes
class | InterpolationFailed

The documentation for this class was generated from the following files:

- polynomi.h
- polynomi.cpp